<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRenderedDocumentDataEntity ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRenderedDocumentDataEntity
 * @subpackage Arrays
 */
class ArrayOfRenderedDocumentDataEntity extends AbstractStructArrayBase
{
    /**
     * The RenderedDocumentDataEntity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\RenderedDocumentDataEntity[]
     */
    public $RenderedDocumentDataEntity;
    /**
     * Constructor method for ArrayOfRenderedDocumentDataEntity
     * @uses ArrayOfRenderedDocumentDataEntity::setRenderedDocumentDataEntity()
     * @param \patest\StructType\RenderedDocumentDataEntity[] $renderedDocumentDataEntity
     */
    public function __construct(array $renderedDocumentDataEntity = array())
    {
        $this
            ->setRenderedDocumentDataEntity($renderedDocumentDataEntity);
    }
    /**
     * Get RenderedDocumentDataEntity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\RenderedDocumentDataEntity[]|null
     */
    public function getRenderedDocumentDataEntity()
    {
        return isset($this->RenderedDocumentDataEntity) ? $this->RenderedDocumentDataEntity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRenderedDocumentDataEntity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRenderedDocumentDataEntity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRenderedDocumentDataEntityForArrayConstraintsFromSetRenderedDocumentDataEntity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem) {
            // validation for constraint: itemType
            if (!$arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem instanceof \patest\StructType\RenderedDocumentDataEntity) {
                $invalidValues[] = is_object($arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem) ? get_class($arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem) : sprintf('%s(%s)', gettype($arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem), var_export($arrayOfRenderedDocumentDataEntityRenderedDocumentDataEntityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RenderedDocumentDataEntity property can only contain items of type \patest\StructType\RenderedDocumentDataEntity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RenderedDocumentDataEntity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\RenderedDocumentDataEntity[] $renderedDocumentDataEntity
     * @return \patest\ArrayType\ArrayOfRenderedDocumentDataEntity
     */
    public function setRenderedDocumentDataEntity(array $renderedDocumentDataEntity = array())
    {
        // validation for constraint: array
        if ('' !== ($renderedDocumentDataEntityArrayErrorMessage = self::validateRenderedDocumentDataEntityForArrayConstraintsFromSetRenderedDocumentDataEntity($renderedDocumentDataEntity))) {
            throw new \InvalidArgumentException($renderedDocumentDataEntityArrayErrorMessage, __LINE__);
        }
        if (is_null($renderedDocumentDataEntity) || (is_array($renderedDocumentDataEntity) && empty($renderedDocumentDataEntity))) {
            unset($this->RenderedDocumentDataEntity);
        } else {
            $this->RenderedDocumentDataEntity = $renderedDocumentDataEntity;
        }
        return $this;
    }
    /**
     * Add item to RenderedDocumentDataEntity value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\RenderedDocumentDataEntity $item
     * @return \patest\ArrayType\ArrayOfRenderedDocumentDataEntity
     */
    public function addToRenderedDocumentDataEntity(\patest\StructType\RenderedDocumentDataEntity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\RenderedDocumentDataEntity) {
            throw new \InvalidArgumentException(sprintf('The RenderedDocumentDataEntity property can only contain items of type \patest\StructType\RenderedDocumentDataEntity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RenderedDocumentDataEntity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\RenderedDocumentDataEntity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\RenderedDocumentDataEntity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\RenderedDocumentDataEntity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\RenderedDocumentDataEntity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\RenderedDocumentDataEntity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RenderedDocumentDataEntity
     */
    public function getAttributeName()
    {
        return 'RenderedDocumentDataEntity';
    }
}
